import { WorkerPAGFile } from './pag-file';
import { WorkerPAGView } from './pag-view';
import { WorkerPAGImage } from './pag-image';
export declare const MAX_ACTIVE_WORKER_CONTEXTS = 4;
export interface PAGWorkerOptions {
    /**
     * Link to wasm file and libpag core script.
     */
    locateFile?: (file: 'libpag.wasm' | 'libpag.js') => string;
    /**
     * Configure for worker.
     */
    workerOptions?: WorkerOptions;
}
export declare const createPAGWorker: (pagWorkerOptions?: PAGWorkerOptions) => Promise<Worker>;
export { WorkerPAGFile, WorkerPAGView, WorkerPAGImage };
